<div *ngIf="hidden" class="lds-dual-ring"></div>
<div *ngIf="!hidden" class="center">
  <div class="dashboard-class">
    <div class="project">
      <div class="proj">
        <button *ngIf="extendedFunctionality" matTooltip="Create Project" class="button-plus mr-3" mat-icon-button
          aria-label="More" (click)='openDialog(createProjectDialog)'>
          <mat-icon class="plus">add</mat-icon>
        </button>
      </div>
      <app-input-filter (changeEvent)="onFilterProjects($event)" [placeholder]='filerPlaceholder'></app-input-filter>
    </div>
    <div class="row">
      <div *ngIf="!filteredDashboards.length" class="nothingFound"> Nothing found </div>
      <div class="col-xl-3 col-lg-4 col-md-6 col-sm-6 col-12" *ngFor="let dashboard of filteredDashboards">
        <div class="mb-4 card card-border-radius">
          <div class="progress">
            <div class="progress-bar"
              [ngStyle]="progressBarColor(dashboard.tasksProgress.closed, dashboard.tasksProgress.total)"
              role="progressbar" attr.aria-valuenow="dashboard.tasksProgress.closed" attr.aria-valuemin="0"
              attr.aria-valuemax="dashboard.tasksProgress.total"></div>
          </div>
          <div class="card-header card-border-radius">
            <mat-chip-list class="d-flex">
              <mat-chip class="chip" [ngStyle]="getChipBackColor(dashboard.projectStatusName)">
                {{dashboard.projectStatusName}}
              </mat-chip>
            </mat-chip-list>
            <div>
              <button mat-button [matMenuTriggerFor]="aboveMenu" mat-icon-button aria-label="More">
                <mat-icon>more_vert</mat-icon>
              </button>
              <mat-menu #aboveMenu="matMenu" yPosition="above">
                <button mat-menu-item (click)="onSettings(dashboard.projectId)">Settings</button>
                <button *ngIf="extendedFunctionality" mat-menu-item
                  (click)="openAddUserToProjectDialog(addUserToProjectDialog, dashboard.projectId, dashboard.projectName)">Invite
                  User</button>
                <button mat-menu-item
                  (click)="openDialog(leaveProjectConfirmationDialog, dashboard.currentProjectManagerId, dashboard.projectId)">Leave
                  Project</button>
                <button *ngIf="extendedFunctionality" mat-menu-item
                  (click)="onDelete(dashboard.projectId)">Delete</button>
              </mat-menu>
            </div>
          </div>
          <div>
            <span [routerLink]="['/dashboard-project-statistic/',dashboard.projectId]"
              class="card-title">{{dashboard.projectName}}</span>
          </div>
          <div class="card-body flex-column">
            <div class="d-flex">
              <div class="ml-2"></div>
              <div class="users-images" *ngFor="let user of dashboard.users">
                <img class="users-images-cards" src="data:image/PNG;base64,{{user.image}}"
                  matTooltip="{{user.fullName}}" [matTooltipPosition]="position.value">
              </div>
            </div>
            <div class="d-flex align-items-center mt-4">
              <mat-icon>playlist_add_check</mat-icon>
              <div class="footer-text">
                {{dashboard.tasksProgress.closed}}/{{dashboard.tasksProgress.total}}
              </div>
            </div>
          </div>
          <div class="card-footer card-border-radius">
            <div class="footer-text" *ngIf="dashboard.startsIn">
              Starts in: {{dashboard.startsIn}} days
            </div>
            <div class="footer-text w-75" *ngIf="dashboard.live != null">
              <div class="d-flex justify-content-between">
                <div>
                  Lives: {{dashboard.live}} days
                </div>
                <div *ngIf="dashboard.total !== undefined && dashboard.live != undefined">
                  Total: {{dashboard.total}} days
                </div>
              </div>
              <div *ngIf="dashboard.total !== undefined && dashboard.live != undefined">
                {{getDeadlineDays(dashboard)}}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<ng-template #addUserToProjectDialog>
  <h1 mat-dialog-title>User invite dialog</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onAddUserToProjectFormSubmit(addUser)" #addUser="ngForm">
      <div class="form-group">
        <label for="inputEmail">Email</label>
        <input type="email" class="form-control" id="inputEmail" #inputEmail="ngModel" name="inputEmail"
          placeholder="you@example.com" [pattern]="emailPattern" ngModel required>
        <div *ngIf="inputEmail.invalid && (inputEmail.touched || addUser.submitted)">
          <div *ngIf="inputEmail.errors.required" class="input-err-text">Email is required.</div>
          <div *ngIf="inputEmail.errors.pattern" class="input-err-text">Email should be like *@*.* format</div>
        </div>
      </div>
      <button mat-button cdkFocusInitial class="create-button">Invite user</button>
    </form>
  </div>
</ng-template>

<ng-template #createProjectDialog>
  <h1 mat-dialog-title>Create Project</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onTryCreateProject(createProjectForm)" #createProjectForm="ngForm">
      <div class="form-group">
        <label for="inputProjectName">Project name</label>
        <div class="input-group">
          <input type="text" class="form-control" id="inputProjectName" placeholder="Project name"
            name="inputProjectName" #inputProjectName="ngModel" ngModel required>
        </div>
        <div *ngIf="inputProjectName.invalid && (createProjectForm.submitted || inputProjectName.touched)">
          <div class="input-err-text">Project name is required.</div>
        </div>
      </div>
      <div class="form-group">
        <label for="inputStatus">Project status</label>
        <select name="inputStatus" id="inputStatus" class="form-control" [(ngModel)]="defaultProjectStatusId">
          <option *ngFor="let status of projectStatusList" [value]="status.projectStatusId">
            {{status.projectStatusName}}
          </option>
        </select>
      </div>
      <div *ngIf="serverError" class="alert alert-danger" role="alert">
        {{errorMessage}}
      </div>
      <div class="alert alert-warning" *ngIf="restoreProjectQuestion" role="alert">
        {{errorMessage}}
        <br>
        <div class="mt-2">
          <button (click)="onRestoreClick(createProjectForm)" class="btn btn-warning mr-3">Restore</button>
          <button (click)="onCreateClick(createProjectForm)" class="btn btn-warning">Create</button>
        </div>
      </div>
      <div class="pt-3">
        <button mat-flat-button class="create-button" type="submit">Create</button>
      </div>
      <div class="pt-3">
        <button mat-flat-button class="cancel-button" type="button" (click)="onCancelClick()">Cancel</button>
      </div>
    </form>
  </div>
</ng-template>

<ng-template #leaveProjectConfirmationDialog>
  <h1 mat-dialog-title>Leave Project</h1>
  <div mat-dialog-content class="text-center">
    Are you sure? <br /> Notice that you <u>can't</u> undo this action
  </div>
  <div mat-dialog-footer class="mt-3">
    <button mat-button class="create-button" (click)="onLeaveProjectClick()">Leave</button>
  </div>
</ng-template>